package com.css.simulation.resource.scene.ctrl;

import api.common.pojo.common.ResponseBodyVO;
import api.common.pojo.constants.DictConstants;
import api.common.pojo.param.MinioParameter;
import api.common.util.FileUtil;
import com.css.simulation.resource.feign.FileDownService;
import feign.Response;
import lombok.extern.slf4j.Slf4j;
import org.springframework.http.MediaType;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.HashMap;
import java.util.Map;

//文件上传下载
@Slf4j
@RestController
@RequestMapping("/file")
public class FileController {

    @Resource
    private FileDownService fileDownService;

    @PostMapping(value = "/upload", consumes = MediaType.MULTIPART_FORM_DATA_VALUE)
    public ResponseBodyVO<Map> upload(@RequestPart("file") MultipartFile file,
                      @RequestParam("type") String type,@RequestParam("objectPath") String objectPath) {
        String fileName="";
        if(type.equals(DictConstants.SCENE_NATURAL)){
            fileName="自然驾驶/"+objectPath+"/"+file.getOriginalFilename();
        }else if(type.equals(DictConstants.SCENE_STANDARD)){
            fileName="标准法规/"+objectPath+"/"+file.getOriginalFilename();
        }else if(type.equals(DictConstants.SCENE_ACCIDENT)){
            fileName="交通事故/"+objectPath+"/"+file.getOriginalFilename();
        }else if(type.equals(DictConstants.SCENE_GENERAL)){
            fileName="泛化场景/"+objectPath+"/"+file.getOriginalFilename();
        }else{
            fileName=file.getOriginalFilename();
        }
       log.info("上传文件名称--------"+file.getOriginalFilename());

        ResponseBodyVO<String> respon=fileDownService.upload(file,fileName);
          String videoPreview=  respon.getMessage();
             Map map=new HashMap();
             map.put("videoPreview",videoPreview);
              map.put("fileName",fileName);

        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS,map);
    }


    @PostMapping(value = "/uploadNew", consumes = MediaType.MULTIPART_FORM_DATA_VALUE)
    public ResponseBodyVO<Map> upload(@RequestPart("file") MultipartFile file) {
        log.info("上传文件名称--------"+file.getOriginalFilename());
        String fileName=file.getOriginalFilename();
        ResponseBodyVO<String> respon=fileDownService.upload(file,fileName);
        String videoPreview=  respon.getMessage();
        Map map=new HashMap();
        map.put("videoPreview",videoPreview);
        map.put("fileName",fileName);

        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS,map);
    }


    @PostMapping(value = "/download")
    public void download(
            HttpServletResponse response,@RequestBody @Validated MinioParameter parms
    ) throws IOException {
        Response download = fileDownService.download(parms);
        Response.Body body = download.body();
        InputStream inputStream = body.asInputStream();
       downloadForHttp(parms.getObjectName(), inputStream, response, 1024);
    }

    @GetMapping(value = "/download1")
    public void download1(
            HttpServletResponse response
    ) throws IOException {
        MinioParameter parms =new MinioParameter();
        parms.setObjectName("simulation.mp4");
        Response download = fileDownService.download(parms);
        Response.Body body = download.body();
        InputStream inputStream = body.asInputStream();
        downloadForHttp(parms.getObjectName(), inputStream, response, 1024);
    }



    public  void downloadForHttp(String fileName, InputStream in, HttpServletResponse response, int bufferSize) throws IOException {
        int idx=fileName.lastIndexOf("/");
        fileName=fileName.substring(idx+1,fileName.length());

        log.info("下载----"+fileName);
        response.setContentType("application/octet-stream;charset=utf-8");
        response.setHeader("Content-Disposition", "attachment;filename=\"" + fileName + "\"");
        copyBytes(in, response.getOutputStream(), bufferSize);
    }

    public static void copyBytes(InputStream in, OutputStream out, int bufferSize) throws IOException {
        byte[] buffer = new byte[bufferSize];
        for (int bytesRead = in.read(buffer); bytesRead >= 0; bytesRead = in.read(buffer)) {
            out.write(buffer, 0, bytesRead);
        }
    }

}